<?xml version="1.0"?>
<launch>
  <!-- Load the top-level (ie: stand-alone and complete) xacro for the UR
       variant defined by the set of yaml parameter files (so to load a UR5
       onto the ROS parameter server, provide paths to the .yaml files which
       contain the limits, kinematics, physical and visual parameters which
       together describe a UR5 robot).

       NOTE: users will typically want to use use one of the other .launch files
       in this directory (ie: 'load_urXXX.launch'), as those already contain
       appropriate default values for the required arguments for the various
       supported robots.

       NOTE2: if you have a custom robot configuration, or your robot is
       integrated into a work cell, do NOT change this file or add all of the
       work cell objects to the ur.xacro file. Create a new top-level xacro and
       include the ur_macro.xacro file into it. Then write a new .launch file
       to load it onto the parameter server.
  -->

  <arg name="robot_model" doc="Type/series of used UR robot (ur3, ur3e, ur5, ur5e, ur10, ur10e, ur16e)" />

  <!--Parameter files -->
  <arg name="joint_limit_params" doc="YAML file containing the joint limit values"/>
  <arg name="kinematics_params" doc="YAML file containing the robot's kinematic parameters. These will be different for each robot as they contain the robot's calibration."/>
  <arg name="physical_params" doc="YAML file containing the phycical parameters of the robots"/>
  <arg name="visual_params" doc="YAML file containing the visual model of the robots"/>

  <!--Common parameters  -->
  <arg name="transmission_hw_interface" default="hardware_interface/EffortJointInterface" doc="The hardware_interface to expose for each joint in the simulated robot (one of: [PositionJointInterface, VelocityJointInterface, EffortJointInterface])"/>
  <arg name="safety_limits" default="false" doc="If True, enable the safety limits controller"/>
  <arg name="safety_pos_margin" default="0.15" doc="The lower/upper limits in the safety controller" />
  <arg name="safety_k_position" default="20" doc="Used to set k position in the safety controller" />

  <param name="robot_description" command="$(find xacro)/xacro '$(find master_scene)models/robot/urdf/ur.xacro'
    robot_model:=$(arg robot_model)
    joint_limit_params:=$(arg joint_limit_params)
    kinematics_params:=$(arg kinematics_params)
    physical_params:=$(arg physical_params)
    visual_params:=$(arg visual_params)
    transmission_hw_interface:=$(arg transmission_hw_interface)
    safety_limits:=$(arg safety_limits)
    safety_pos_margin:=$(arg safety_pos_margin)
    safety_k_position:=$(arg safety_k_position)"
    />
</launch>